import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.Map;
import java.util.ResourceBundle;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.netbeans.spi.wizard.WizardPage;


public class OsamesParametres extends WizardPage {

	private JTextField txtUser;
	private JTextField txtPassword;
	private JTextField txtDb;
	private JTextField txtSmtp;
	private JTextField txtExpediteur;
	private JRadioButton rbChargerCommunes;
	private JRadioButton rbPasChargerCommunes;
	
	public OsamesParametres(Map settings) {
		FlowLayout flLayout = (FlowLayout)getLayout();
		flLayout.setAlignment(FlowLayout.LEFT);
		flLayout.setVgap(20);
		
		add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.preambule")));
		
		GridLayout glayout = new GridLayout(5, 2);
		glayout.setVgap(10);
		glayout.setHgap(5);
		
		JPanel grille = new JPanel(glayout);
		JPanel params = new JPanel(new BorderLayout());
		
		this.txtDb = new JTextField(((ResourceBundle)settings.get("messages")).getString("osames.db"));
		this.txtUser = new JTextField(((ResourceBundle)settings.get("messages")).getString("osames.user"));
		this.txtPassword = new JTextField(((ResourceBundle)settings.get("messages")).getString("osames.user.password"));
		this.txtSmtp = new JTextField(((ResourceBundle)settings.get("messages")).getString("osames.smtp"));
		this.txtExpediteur = new JTextField();
		txtDb.setName("txtDb");
		txtDb.setColumns(15);
		txtUser.setName("txtUser");
		txtUser.setColumns(15);
		txtPassword.setName("txtPassword");
		txtPassword.setColumns(15);
		txtSmtp.setName("txtSmtp");
		txtExpediteur.setName("txtExpediteur");
		
		JPanel panelCommunes = new JPanel();
		((FlowLayout)panelCommunes.getLayout()).setAlignment(FlowLayout.LEFT);
		((FlowLayout)panelCommunes.getLayout()).setHgap(0);
		panelCommunes.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.communes")));
		ButtonGroup bg = new ButtonGroup();
		rbChargerCommunes = new JRadioButton(((ResourceBundle)settings.get("messages")).getString("osames.oui"));
		rbPasChargerCommunes = new JRadioButton(((ResourceBundle)settings.get("messages")).getString("osames.non"));
		rbChargerCommunes.setName("rbChargerCommunes");
		rbPasChargerCommunes.setName("rbPasChargerCommunes");
		bg.add(rbChargerCommunes);
		bg.add(rbPasChargerCommunes);
		JPanel panelBoutons = new JPanel();
		FlowLayout layoutPanelBoutons = (FlowLayout)panelBoutons.getLayout();
		layoutPanelBoutons.setAlignment(FlowLayout.RIGHT);
		layoutPanelBoutons.setHgap(15);
		panelBoutons.add(rbChargerCommunes);
		panelBoutons.add(rbPasChargerCommunes);
		panelCommunes.add(panelBoutons);
		
		grille.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.db")));
		grille.add(txtDb);
		grille.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.user")));
		grille.add(txtUser);
		grille.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.password")));
		grille.add(txtPassword);
		grille.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.smtp")));
		grille.add(txtSmtp);
		grille.add(new JLabel(((ResourceBundle)settings.get("messages")).getString("gui.osamesparams.lbl.expediteur")));
		grille.add(txtExpediteur);
		
		params.add(grille, BorderLayout.NORTH);
		params.add(panelCommunes, BorderLayout.SOUTH);
		add(params);
		
	}
	
	protected String validateContents (Component component, Object o) {
		if (this.txtDb.getText().length() == 0)
			return ((ResourceBundle)getWizardDataMap().get("messages")).getString("gui.osamesparams.validation.erreur.db");
		else if (this.txtUser.getText().length() == 0)
			return ((ResourceBundle)getWizardDataMap().get("messages")).getString("gui.osamesparams.validation.erreur.user");
		else if (this.txtPassword.getText().length() == 0)
			return ((ResourceBundle)getWizardDataMap().get("messages")).getString("gui.osamesparams.validation.erreur.password");
		else if (!(this.rbChargerCommunes.isSelected() || this.rbPasChargerCommunes.isSelected()))
			return ((ResourceBundle)getWizardDataMap().get("messages")).getString("gui.osamesparams.validation.erreur.communes");
		return null;
	}

}
